/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERV                                                     */
/* Tabela : SERVICO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SERV'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SERV
GO

CREATE TRIGGER DTULTATU_SERV
ON SERVICO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERVICO', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';' +
                                            'CDSERVFILI='+ CDSERVFILI+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERVICO
      SET DTULTATUSERV = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(SERVICO.CDFILIAL,    '') = ISNULL(INSERTED.CDFILIAL,    '')) AND
            (ISNULL(SERVICO.CDSERVFILI,  '') = ISNULL(INSERTED.CDSERVFILI,  '')) AND
            (ISNULL(SERVICO.NMSERVICO,   '') = ISNULL(INSERTED.NMSERVICO,   '')) AND
            (ISNULL(SERVICO.QTCOMESTIDOM, -1) = ISNULL(INSERTED.QTCOMESTIDOM, -1)) AND
            (ISNULL(SERVICO.QTCLIESTIDOM, -1) = ISNULL(INSERTED.QTCLIESTIDOM, -1)) AND
            (ISNULL(SERVICO.QTFUNESTIDOM, -1) = ISNULL(INSERTED.QTFUNESTIDOM, -1)) AND
            (ISNULL(SERVICO.QTDOAESTIDOM, -1) = ISNULL(INSERTED.QTDOAESTIDOM, -1)) AND
            (ISNULL(SERVICO.QTCOMESTISEG, -1) = ISNULL(INSERTED.QTCOMESTISEG, -1)) AND
            (ISNULL(SERVICO.QTCLIESTISEG, -1) = ISNULL(INSERTED.QTCLIESTISEG, -1)) AND
            (ISNULL(SERVICO.QTFUNESTISEG, -1) = ISNULL(INSERTED.QTFUNESTISEG, -1)) AND
            (ISNULL(SERVICO.QTDOAESTISEG, -1) = ISNULL(INSERTED.QTDOAESTISEG, -1)) AND
            (ISNULL(SERVICO.QTCOMESTITER, -1) = ISNULL(INSERTED.QTCOMESTITER, -1)) AND
            (ISNULL(SERVICO.QTCLIESTITER, -1) = ISNULL(INSERTED.QTCLIESTITER, -1)) AND
            (ISNULL(SERVICO.QTFUNESTITER, -1) = ISNULL(INSERTED.QTFUNESTITER, -1)) AND
            (ISNULL(SERVICO.QTDOAESTITER, -1) = ISNULL(INSERTED.QTDOAESTITER, -1)) AND
            (ISNULL(SERVICO.QTCOMESTIQUA, -1) = ISNULL(INSERTED.QTCOMESTIQUA, -1)) AND
            (ISNULL(SERVICO.QTCLIESTIQUA, -1) = ISNULL(INSERTED.QTCLIESTIQUA, -1)) AND
            (ISNULL(SERVICO.QTFUNESTIQUA, -1) = ISNULL(INSERTED.QTFUNESTIQUA, -1)) AND
            (ISNULL(SERVICO.QTDOAESTIQUA, -1) = ISNULL(INSERTED.QTDOAESTIQUA, -1)) AND
            (ISNULL(SERVICO.QTCOMESTIQUI, -1) = ISNULL(INSERTED.QTCOMESTIQUI, -1)) AND
            (ISNULL(SERVICO.QTCLIESTIQUI, -1) = ISNULL(INSERTED.QTCLIESTIQUI, -1)) AND
            (ISNULL(SERVICO.QTFUNESTIQUI, -1) = ISNULL(INSERTED.QTFUNESTIQUI, -1)) AND
            (ISNULL(SERVICO.QTDOAESTIQUI, -1) = ISNULL(INSERTED.QTDOAESTIQUI, -1)) AND
            (ISNULL(SERVICO.QTCOMESTISEX, -1) = ISNULL(INSERTED.QTCOMESTISEX, -1)) AND
            (ISNULL(SERVICO.QTCLIESTISEX, -1) = ISNULL(INSERTED.QTCLIESTISEX, -1)) AND
            (ISNULL(SERVICO.QTFUNESTISEX, -1) = ISNULL(INSERTED.QTFUNESTISEX, -1)) AND
            (ISNULL(SERVICO.QTDOAESTISEX, -1) = ISNULL(INSERTED.QTDOAESTISEX, -1)) AND
            (ISNULL(SERVICO.QTCOMESTISAB, -1) = ISNULL(INSERTED.QTCOMESTISAB, -1)) AND
            (ISNULL(SERVICO.QTCLIESTISAB, -1) = ISNULL(INSERTED.QTCLIESTISAB, -1)) AND
            (ISNULL(SERVICO.QTFUNESTISAB, -1) = ISNULL(INSERTED.QTFUNESTISAB, -1)) AND
            (ISNULL(SERVICO.QTDOAESTISAB, -1) = ISNULL(INSERTED.QTDOAESTISAB, -1)) AND
            (ISNULL(SERVICO.QTCOMESTIFER, -1) = ISNULL(INSERTED.QTCOMESTIFER, -1)) AND
            (ISNULL(SERVICO.QTCLIESTIFER, -1) = ISNULL(INSERTED.QTCLIESTIFER, -1)) AND
            (ISNULL(SERVICO.QTFUNESTIFER, -1) = ISNULL(INSERTED.QTFUNESTIFER, -1)) AND
            (ISNULL(SERVICO.QTDOAESTIFER, -1) = ISNULL(INSERTED.QTDOAESTIFER, -1)) AND
            (ISNULL(SERVICO.HRINICATEN,  '') = ISNULL(INSERTED.HRINICATEN,  '')) AND
            (ISNULL(SERVICO.IDTPSERVHOSP,'') = ISNULL(INSERTED.IDTPSERVHOSP,'')) AND
            (ISNULL(SERVICO.IDSERVPADR,  '') = ISNULL(INSERTED.IDSERVPADR,  '')) AND
            (ISNULL(SERVICO.CDGRUPSERV,  '') = ISNULL(INSERTED.CDGRUPSERV,  '')) AND
            (ISNULL(SERVICO.IDTIPOSERV,  '') = ISNULL(INSERTED.IDTIPOSERV,  '')) AND
            (ISNULL(SERVICO.IDSERVTRAN,  '') = ISNULL(INSERTED.IDSERVTRAN,  '')) AND
            (ISNULL(SERVICO.CDROTATRANS, '') = ISNULL(INSERTED.CDROTATRANS, '')) AND
            (ISNULL(SERVICO.IDCONSSERVCA,'') = ISNULL(INSERTED.IDCONSSERVCA,'')) AND
            (ISNULL(SERVICO.CDPRODUTO,   '') = ISNULL(INSERTED.CDPRODUTO,   ''));
   END;
END;
GO

UPDATE SERVICO SET DTULTATUSERV = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUSERV IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUSERV' and
            type = 'D')
   ALTER TABLE SERVICO DROP CONSTRAINT DEFAULT_DTULTATUSERV
GO

ALTER TABLE SERVICO ADD CONSTRAINT DEFAULT_DTULTATUSERV
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUSERV
GO



-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SERV','4.11.194';
GO

