CREATE OR REPLACE PROCEDURE PROJETA_ESTOQUE(
                              P_FILIPROC    IN  ITEMSOLI.CDFILSOLI%TYPE,
                              P_CDFILIAL    IN  ITEMSOLI.CDFILSOLI%TYPE,
                              P_DTLEVINI    IN  ITEMSOLI.DTPROGENTR%TYPE,
                              P_DTLEVFIN    IN  ITEMSOLI.DTPROGENTR%TYPE,
                              P_PRODINI     IN  PRODUTO.CDARVPROD%TYPE,
                              P_PRODFIN     IN  PRODUTO.CDARVPROD%TYPE,
                              P_FILESTOQ    IN  VARCHAR2,
                              P_IDGERSOL    IN  VARCHAR2,
                              P_CONSSOL     IN  VARCHAR2,
                              P_CONSAF      IN  VARCHAR2,
                              P_CONSEST     IN  VARCHAR2,
                              P_CONSROM     IN  VARCHAR2,
                              P_FILIROM     IN  VARCHAR2,
                              P_SERIROM     IN  VARCHAR2,
                              P_OPERADOR    IN  SOLICITA.CDOPERADOR%TYPE,
                              P_TODOSPRODEST IN VARCHAR2 DEFAULT NULL,
                              P_NRSEQESTPROJ OUT TRAB_ESTPROJET.NRSEQESTPROJ%TYPE)
IS
   V_NRESTPROJET VARCHAR2(20);
   V_NRSOLICMP   VARCHAR2(20);

   V_QTESTOQUE  NUMBER;
   V_ESTOQFILI  NUMBER;
   V_CDPRODPREF VARCHAR2(10);
   V_EXISTE     INT;

   V_VRFATOCONV PRODUTO.VRFATOCONV%TYPE;
   V_VRARREDCMP PRODUTO.VRARREDCMP%TYPE;

   V_QTACOMPRAR NUMBER(15,5);

   V_CDSEQUENCIAL VARCHAR2(20);
BEGIN
   V_NRESTPROJET := NULL;
   NOVO_CODIGO('TRAB_ESTPROJET'||P_CDFILIAL, V_NRESTPROJET, 1);
   P_NRSEQESTPROJ := SUBSTR(V_NRESTPROJET,11,10);

   IF P_CONSSOL = 'R' THEN
      NOVO_CODIGO('CONSPLAN'||P_CDFILIAL, V_CDSEQUENCIAL,1);
      V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);
      /*PREENCHE OS DADOS NECESSRIOS PARA CUSTO PLANEJADO - TABELA CONSPLAN*/
      CONSUMO_PLANEJADO_PLA(P_CDFILIAL,
                            'T',
                            P_DTLEVINI,
                            P_DTLEVFIN,
                            'T',
                            'CFP',
                            'N',
                            0,
                            'N',
                            V_CDSEQUENCIAL,
                            '0',
                            'zzzzzzzzzz',
                            '', --> Nenhum operador ser necessrio aqui
                            '_'||TO_CHAR(P_DTLEVINI, 'YYYYMMDD')||'_',
                            '_'||TO_CHAR(P_DTLEVFIN, 'YYYYMMDD')||'_'
                            );

   END IF;

   FOR C_DATA IN   /* Seleciona as Datas do Perodo Informado */
    (SELECT
       DTDATA
     FROM
       DATA
     WHERE
       DTDATA BETWEEN P_DTLEVINI AND P_DTLEVFIN)
   LOOP
     IF P_CONSAF = 'S' THEN
       /* Entrada de Produto -  Autorizao de Fornecimento */
       FOR C_ITEMAUTF IN
        (SELECT
           PRODUTO.CDPRODESTO,
           SUM((ITEMAUTF.QTPROGENTAF - NVL(ITEMAUTF.QTEFETENTRAF,0)) * PRODUTO.VRFATOCONV) AS QTPROGENTAF
         FROM
            PRODUTO,
            ITEMAUTF
         WHERE
           ITEMAUTF.CDFILDEST   = P_CDFILIAL      AND
           ITEMAUTF.DTPROGENTAF = C_DATA.DTDATA   AND
           PRODUTO.CDARVPROD  BETWEEN P_PRODINI  AND P_PRODFIN AND
           ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO AND
           NVL(ITEMAUTF.IDBAIXITMAF, '1') = '1' AND
           NOT EXISTS
              (SELECT
                  CDFILLANC
               FROM
                  AUTOFORNE
               WHERE
                  AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC AND
                  AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST AND
                  AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                  AUTOFORNE.IDBAIXAAF  IN('4','5','6'))
         GROUP BY
           PRODUTO.CDPRODESTO)
       LOOP
         SELECT
           COUNT(*) INTO V_EXISTE
         FROM
           TRAB_ESTPROJET
         WHERE
           CDFILESTPROJ = P_CDFILIAL                   AND
           NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
           CDPROESTPROJ = C_ITEMAUTF.CDPRODESTO;

         IF V_EXISTE = 0 THEN

           V_QTESTOQUE   := 0;
           IF P_CONSEST = 'S' THEN
             FOR C_FILIAL IN
              (SELECT
                 CDFILIAL
               FROM
                 FILIAL
               WHERE
                 INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0) /* Alterao Apetit retirado CDFILIAL e incluido P_CDFILIAL*/
             LOOP
               V_ESTOQFILI := 0;
               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                 CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                 C_ITEMAUTF.CDPRODESTO,
                                 P_DTLEVINI + 1) INTO V_ESTOQFILI
               FROM
                 PARAMGERAL;

               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;
             END LOOP;
           END IF;
           INSERT INTO TRAB_ESTPROJET
              (CDFILESTPROJ,
               NRSEQESTPROJ,
               CDPROESTPROJ,
               QTPRODESTOQ,
               QTPRODLANCAF,
               QTPROJESTPRO)
           VALUES
              (P_CDFILIAL,
               SUBSTR(V_NRESTPROJET,11,10),
               C_ITEMAUTF.CDPRODESTO,
               NVL(V_QTESTOQUE, 0),
               C_ITEMAUTF.QTPROGENTAF,
               NVL(V_QTESTOQUE, 0) + C_ITEMAUTF.QTPROGENTAF);
         ELSE
           UPDATE TRAB_ESTPROJET
           SET QTPRODLANCAF = NVL(QTPRODLANCAF,0) + C_ITEMAUTF.QTPROGENTAF,
               QTPROJESTPRO = NVL(QTPROJESTPRO,0) + C_ITEMAUTF.QTPROGENTAF
           WHERE
             CDFILESTPROJ = P_CDFILIAL     AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMAUTF.CDPRODESTO;
         END IF;
       END LOOP;
     END IF;

     /* Entrada de Produto -  Pedido */
     IF P_CONSAF = 'S' THEN
        FOR C_ITEMAUTF IN
        (SELECT
             PRODUTO.CDPRODESTO,
             SUM(NVL(ITEMPEDEXOL.QTATENDPEDOL, ITEMPEDEXOL.QTPROGENPEOL)* PRODUTO.VRFATOCONV) QTPROGENTAF
          FROM
             ITEMPEDEXOL,
             PEDIDOEXOL,
             PRODUTO,
             FILIAL
          WHERE ITEMPEDEXOL.CDFILDEST     = PEDIDOEXOL.CDFILDEST
            AND ITEMPEDEXOL.CDFILLANC     = PEDIDOEXOL.CDFILLANC
            AND ITEMPEDEXOL.NRPEDEXOL     = PEDIDOEXOL.NRPEDEXOL
            AND NVL(PEDIDOEXOL.IDBAIXEXOL, '0') NOT IN ('4', '5')
            AND ITEMPEDEXOL.IDBAIXAOLSAI IS NULL
            AND ITEMPEDEXOL.CDPRODUTO     = PRODUTO.CDPRODUTO
            AND PRODUTO.CDARVPROD  BETWEEN P_PRODINI  AND P_PRODFIN
            AND ITEMPEDEXOL.DTPROGENPEOL  = C_DATA.DTDATA
            AND FILIAL.CDFILIAL           = P_CDFILIAL
            AND P_CDFILIAL = (CASE 
                                 WHEN FILIAL.IDFUNCAOFILI = 'O' 
                                 THEN PEDIDOEXOL.CDFILIOPELOG 
                                 ELSE PEDIDOEXOL.CDFILDEST 
                              END)
          GROUP BY
             PRODUTO.CDPRODESTO)
       LOOP
         SELECT
           COUNT(*) INTO V_EXISTE
         FROM
           TRAB_ESTPROJET
         WHERE
           CDFILESTPROJ = P_CDFILIAL                   AND
           NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
           CDPROESTPROJ = C_ITEMAUTF.CDPRODESTO;

         IF V_EXISTE = 0 THEN

           V_QTESTOQUE   := 0;
           IF P_CONSEST = 'S' THEN
             FOR C_FILIAL IN
              (SELECT
                 CDFILIAL
               FROM
                 FILIAL
               WHERE
                 INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0)  /* Alterao Apetit retirado CDFILIAL e incluido P_CDFILIAL*/
             LOOP
               V_ESTOQFILI := 0;
               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                 CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                 C_ITEMAUTF.CDPRODESTO,
                                 P_DTLEVINI + 1) INTO V_ESTOQFILI
               FROM
                 PARAMGERAL;

               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;
             END LOOP;
           END IF;
           INSERT INTO TRAB_ESTPROJET
              (CDFILESTPROJ,
               NRSEQESTPROJ,
               CDPROESTPROJ,
               QTPRODESTOQ,
               QTPRODLANCAF,
               QTPROJESTPRO)
           VALUES
              (P_CDFILIAL,
               SUBSTR(V_NRESTPROJET,11,10),
               C_ITEMAUTF.CDPRODESTO,
               NVL(V_QTESTOQUE, 0),
               C_ITEMAUTF.QTPROGENTAF,
               NVL(V_QTESTOQUE, 0) + C_ITEMAUTF.QTPROGENTAF);
         ELSE
           UPDATE TRAB_ESTPROJET
           SET QTPRODLANCAF = NVL(QTPRODLANCAF,0) + C_ITEMAUTF.QTPROGENTAF,
               QTPROJESTPRO = NVL(QTPROJESTPRO,0) + C_ITEMAUTF.QTPROGENTAF
           WHERE
             CDFILESTPROJ = P_CDFILIAL     AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMAUTF.CDPRODESTO;
         END IF;
       END LOOP;
     END IF;

     IF P_CONSSOL = 'S' THEN
       FOR C_ITEMSOLI IN
        (SELECT
           PRODUTO.CDPRODESTO,
           SUM(QTPREVCONS) AS QTSOLIPROD
         FROM
           PRODUTO,
           PREVCONS
         WHERE
           PREVCONS.CDFILIAL  = P_CDFILIAL        AND
           PRODUTO.CDARVPROD  BETWEEN P_PRODINI   AND P_PRODFIN AND
           PREVCONS.CDPRODUTO  = PRODUTO.CDPRODUTO AND
           PREVCONS.DTPREVCONS = C_DATA.DTDATA
         GROUP BY
           PRODUTO.CDPRODESTO)
       LOOP
         SELECT
           COUNT(*) INTO V_EXISTE
         FROM
           TRAB_ESTPROJET
         WHERE
           CDFILESTPROJ = P_CDFILIAL     AND
           NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
           CDPROESTPROJ = C_ITEMSOLI.CDPRODESTO;

         IF V_EXISTE = 0 THEN

           V_QTESTOQUE   := 0;
           IF P_CONSEST = 'S' THEN
             FOR C_FILIAL IN
              (SELECT
                 CDFILIAL
               FROM
                 FILIAL
               WHERE
                 INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0) /* Alterao Apetit retirado CDFILIAL e incluido P_CDFILIAL*/
             LOOP
               V_ESTOQFILI := 0;
               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                 CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                 C_ITEMSOLI.CDPRODESTO,
                                 P_DTLEVINI + 1) INTO V_ESTOQFILI
               FROM
                 PARAMGERAL;

               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;
             END LOOP;
           END IF;

           INSERT INTO TRAB_ESTPROJET
              (CDFILESTPROJ,
               NRSEQESTPROJ,
               CDPROESTPROJ,
               QTPRODESTOQ,
               QTPRODSOLI,
               QTPROJESTPRO)
           VALUES
              (P_CDFILIAL,
               SUBSTR(V_NRESTPROJET,11,10),
               C_ITEMSOLI.CDPRODESTO,
               NVL(V_QTESTOQUE, 0),
               C_ITEMSOLI.QTSOLIPROD,
               NVL(V_QTESTOQUE, 0) - C_ITEMSOLI.QTSOLIPROD);

           IF (NVL(V_QTESTOQUE, 0) - C_ITEMSOLI.QTSOLIPROD) <0 THEN
              UPDATE TRAB_ESTPROJET
              SET DTPRIFALTEST = C_DATA.DTDATA
              WHERE
                QTPROJESTPRO < 0                            AND
                DTPRIFALTEST IS NULL                        AND
                CDFILESTPROJ = P_CDFILIAL                   AND
                NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
                CDPROESTPROJ = C_ITEMSOLI.CDPRODESTO;
           END IF;
         ELSE
           UPDATE TRAB_ESTPROJET
           SET QTPRODSOLI   = NVL(QTPRODSOLI,0)   + C_ITEMSOLI.QTSOLIPROD,
               QTPROJESTPRO = NVL(QTPROJESTPRO,0) - C_ITEMSOLI.QTSOLIPROD
           WHERE
             CDFILESTPROJ = P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMSOLI.CDPRODESTO;

           UPDATE TRAB_ESTPROJET
           SET DTPRIFALTEST = C_DATA.DTDATA
           WHERE
             QTPROJESTPRO < 0                            AND
             DTPRIFALTEST IS NULL                        AND
             CDFILESTPROJ = P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMSOLI.CDPRODESTO;
         END IF;
       END LOOP;
     END IF;

     IF P_CONSSOL = 'R' THEN /* CONSIDERAR REQUISICAO DO PERIODO */

       FOR C_ITEMREQ IN
        (SELECT PRODUTO.CDPRODUTO,
                SUM(CONSPLAN.QTCONSPLAN) AS QTCONSPLAN
           FROM PRODUTO, CONSPLAN, SERVICO
          WHERE CONSPLAN.NRCONSPLAN = V_CDSEQUENCIAL
            AND CONSPLAN.CDFILICPLA = P_CDFILIAL
            AND PRODUTO.CDARVPROD BETWEEN P_PRODINI  AND P_PRODFIN
            AND CONSPLAN.CDPRODCPLA = PRODUTO.CDPRODUTO
            AND CONSPLAN.DTCONSPLAN = C_DATA.DTDATA
            AND CONSPLAN.CDSERVCPLA = SERVICO.CDSERVFILI
            AND CONSPLAN.CDFILICPLA = SERVICO.CDFILIAL
            AND SERVICO.IDSERVATIV = 'S'
         GROUP BY
           PRODUTO.CDPRODUTO)
       LOOP
         SELECT
           COUNT(*) INTO V_EXISTE
         FROM
           TRAB_ESTPROJET
         WHERE
           CDFILESTPROJ = P_CDFILIAL     AND
           NRSEQESTPROJ = SUBSTR(V_NRESTPROJET, 11, 10)  AND
           CDPROESTPROJ = C_ITEMREQ.CDPRODUTO;

         IF V_EXISTE = 0 THEN

           V_QTESTOQUE   := 0;
           IF P_CONSEST = 'S' THEN
             FOR C_FILIAL IN
              (SELECT
                 CDFILIAL
               FROM
                 FILIAL
               WHERE
                 INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0) /* Alterao Apetit retirado CDFILIAL e incluido P_CDFILIAL*/
             LOOP
               V_ESTOQFILI := 0;
               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                 CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                 C_ITEMREQ.CDPRODUTO,
                                 P_DTLEVINI + 1) INTO V_ESTOQFILI
               FROM
                 PARAMGERAL;

               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;
             END LOOP;
           END IF;

           INSERT INTO TRAB_ESTPROJET
              (CDFILESTPROJ,
               NRSEQESTPROJ,
               CDPROESTPROJ,
               QTPRODESTOQ,
               QTPRODSOLI,
               QTPROJESTPRO)
           VALUES
              (P_CDFILIAL,
               SUBSTR(V_NRESTPROJET,11,10),
               C_ITEMREQ.CDPRODUTO,
               NVL(V_QTESTOQUE, 0),
               C_ITEMREQ.QTCONSPLAN,
               NVL(V_QTESTOQUE, 0) - C_ITEMREQ.QTCONSPLAN);

           IF (NVL(V_QTESTOQUE, 0) - C_ITEMREQ.QTCONSPLAN) <0 THEN
              UPDATE TRAB_ESTPROJET
              SET DTPRIFALTEST = C_DATA.DTDATA
              WHERE
                QTPROJESTPRO < 0                            AND
                DTPRIFALTEST IS NULL                        AND
                CDFILESTPROJ = P_CDFILIAL                   AND
                NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
                CDPROESTPROJ = C_ITEMREQ.CDPRODUTO;
           END IF;
         ELSE
           UPDATE TRAB_ESTPROJET
           SET QTPRODSOLI   = NVL(QTPRODSOLI,0)   + C_ITEMREQ.QTCONSPLAN,
               QTPROJESTPRO = NVL(QTPROJESTPRO,0) - C_ITEMREQ.QTCONSPLAN
           WHERE
             CDFILESTPROJ = P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMREQ.CDPRODUTO;

           UPDATE TRAB_ESTPROJET
           SET DTPRIFALTEST = C_DATA.DTDATA
           WHERE
             QTPROJESTPRO < 0                            AND
             DTPRIFALTEST IS NULL                        AND
             CDFILESTPROJ = P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMREQ.CDPRODUTO;
         END IF;
       END LOOP;

     END IF;

     IF P_CONSROM = 'S' THEN
       /* Sada de Produto - Romaneio(NF's Previstas - sem evoluo no estoque) */
       FOR C_ITEMPRODUTO IN
        (SELECT
           PRODUTO.CDPRODESTO,
           SUM(ITEMPRODUTO.QTITEMPROD * PRODUTO.VRFATOCONV) AS QTITEMPROD
         FROM
           PRODUTO,
           ITEMPRODUTO,
           NOTAFISCAL,
           LANCTOESTOQ,
           ITLANCTOEST,
           SERIENF,
           FILIAL
         WHERE
           ITLANCTOEST.IDEVOLESTOQ = 'N'                    AND
           ITLANCTOEST.CDFILIAL    = LANCTOESTOQ.CDFILIAL   AND
           ITLANCTOEST.NRLANCESTQ  = LANCTOESTOQ.NRLANCESTQ AND
           LANCTOESTOQ.CDFILIAL    = NOTAFISCAL.CDFILIAL    AND
           LANCTOESTOQ.NRLANCTONF  = NOTAFISCAL.NRLANCTONF  AND
           NOTAFISCAL.IDENTRSAIDOP = 'S'                    AND
           INSTR(NVL(P_FILIROM, FILIAL.CDFILIAL), FILIAL.CDFILIAL) <> 0 AND
           SERIENF.CDEMPRESA       = FILIAL.CDEMPRESA       AND
           SERIENF.CDINSCESTA      = FILIAL.CDINSCESTA      AND
           SERIENF.CDINSCMUNI      = FILIAL.CDINSCMUNI      AND
           INSTR(NVL(P_SERIROM, SERIENF.CDSERIE), SERIENF.CDSERIE) <> 0 AND
           NOTAFISCAL.CDFILIEMIT   = FILIAL.CDFILIAL        AND
           NOTAFISCAL.CDSERIE      = SERIENF.CDSERIE        AND
           NOTAFISCAL.DTENTRSAID   = C_DATA.DTDATA          AND
           PRODUTO.CDARVPROD   BETWEEN P_PRODINI  AND P_PRODFIN AND
           ITEMPRODUTO.CDPRODUTO   = PRODUTO.CDPRODUTO      AND
           ITEMPRODUTO.CDFILIAL    = NOTAFISCAL.CDFILIAL    AND
           ITEMPRODUTO.NRLANCTONF  = NOTAFISCAL.NRLANCTONF
         GROUP BY
           PRODUTO.CDPRODESTO)
       LOOP
         SELECT
           COUNT(*) INTO V_EXISTE
         FROM
           TRAB_ESTPROJET
         WHERE
           CDFILESTPROJ = P_CDFILIAL     AND
           NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
           CDPROESTPROJ = C_ITEMPRODUTO.CDPRODESTO;

         IF V_EXISTE = 0 THEN

           V_QTESTOQUE   := 0;
           IF P_CONSEST = 'S' THEN
             FOR C_FILIAL IN
              (SELECT
                 CDFILIAL
               FROM
                 FILIAL
               WHERE
                 INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0)  /* Alterao Apetit retirado CDFILIAL e incluido P_CDFILIAL*/
             LOOP
               V_ESTOQFILI := 0;

               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                 CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                 C_ITEMPRODUTO.CDPRODESTO,
                                 P_DTLEVINI + 1) INTO V_ESTOQFILI
               FROM
                 PARAMGERAL;
               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;

             END LOOP;

           END IF;

           INSERT INTO TRAB_ESTPROJET
              (CDFILESTPROJ,
               NRSEQESTPROJ,
               CDPROESTPROJ,
               QTPRODESTOQ,
               QTPRODNFPREV,
               QTPROJESTPRO)
           VALUES
              (P_CDFILIAL,
               SUBSTR(V_NRESTPROJET,11,10),
               C_ITEMPRODUTO.CDPRODESTO,
               NVL(V_QTESTOQUE, 0),
               C_ITEMPRODUTO.QTITEMPROD,
               NVL(V_QTESTOQUE, 0) - C_ITEMPRODUTO.QTITEMPROD);

           IF (NVL(V_QTESTOQUE, 0) - C_ITEMPRODUTO.QTITEMPROD) <0 THEN
             UPDATE TRAB_ESTPROJET
             SET DTPRIFALTEST = C_DATA.DTDATA
             WHERE
               QTPROJESTPRO < 0                            AND
               DTPRIFALTEST IS NULL                        AND
               CDFILESTPROJ = P_CDFILIAL                   AND
               NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
               CDPROESTPROJ = C_ITEMPRODUTO.CDPRODESTO;
           END IF;
         ELSE
           UPDATE TRAB_ESTPROJET
           SET QTPRODNFPREV = NVL(QTPRODNFPREV,0) + C_ITEMPRODUTO.QTITEMPROD,
               QTPROJESTPRO = NVL(QTPROJESTPRO,0) - C_ITEMPRODUTO.QTITEMPROD
           WHERE
             CDFILESTPROJ = P_CDFILIAL                   AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMPRODUTO.CDPRODESTO;

           UPDATE TRAB_ESTPROJET
           SET DTPRIFALTEST = C_DATA.DTDATA
           WHERE
             QTPROJESTPRO < 0              AND
             DTPRIFALTEST IS NULL          AND
             CDFILESTPROJ = P_CDFILIAL     AND
             NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)  AND
             CDPROESTPROJ = C_ITEMPRODUTO.CDPRODESTO;
         END IF;
       END LOOP;
     END IF;
   END LOOP;

   /* Verifica todos os produtos que possuam estoque - Efetua projeo de todos os produtos do estoque */
--fab
   IF P_TODOSPRODEST = 'S' THEN
      FOR C_PROD IN
         (SELECT CDPRODUTO
            FROM PRODUTO
           WHERE CDARVPROD BETWEEN P_PRODINI AND P_PRODFIN
             AND CDPRODUTO = CDPRODESTO
             AND CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO))
      LOOP
         SELECT COUNT(*)
           INTO V_EXISTE
           FROM TRAB_ESTPROJET
          WHERE CDFILESTPROJ = P_CDFILIAL
            AND NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10)
            AND CDPROESTPROJ = C_PROD.CDPRODUTO;

         IF V_EXISTE = 0 THEN
            V_QTESTOQUE := 0;

            FOR C_FILIAL IN
               (SELECT CDFILIAL
                  FROM FILIAL
                 WHERE INSTR(NVL(P_FILESTOQ, P_CDFILIAL), CDFILIAL) <> 0)
            LOOP
               V_ESTOQFILI := 0;
               SELECT /* Busca a Quantidade em estoque para o Produto corrente
                         at a data de nicio do levantamento */
                  CALC_ESTOQ_PREV(C_FILIAL.CDFILIAL,
                                   C_PROD.CDPRODUTO,
                                   P_DTLEVINI + 1)
                 INTO V_ESTOQFILI
                 FROM PARAMGERAL;

               V_QTESTOQUE := V_QTESTOQUE + V_ESTOQFILI;
            END LOOP;

            INSERT INTO TRAB_ESTPROJET
               (CDFILESTPROJ,
                NRSEQESTPROJ,
                CDPROESTPROJ,
                QTPRODESTOQ,
                QTPRODLANCAF,
                QTPROJESTPRO)
            VALUES
               (P_CDFILIAL,
                SUBSTR(V_NRESTPROJET,11,10),
                C_PROD.CDPRODUTO,
                NVL(V_QTESTOQUE, 0),
                0,
                NVL(V_QTESTOQUE, 0));
         END IF;
      END LOOP;
   END IF;

   IF P_IDGERSOL = 'S' THEN
     FOR C_ESTPROJ IN
      (SELECT
         DTPRIFALTEST,
         CDPROESTPROJ,
         QTPROJESTPRO
       FROM
         TRAB_ESTPROJET
       WHERE
         QTPROJESTPRO  < 0                           AND
         CDFILESTPROJ = P_CDFILIAL                   AND
         NRSEQESTPROJ = SUBSTR(V_NRESTPROJET,11,10))
     LOOP

       IF V_NRSOLICMP IS NULL THEN
         NOVO_CODIGO('SOLICOMP'||P_CDFILIAL||P_FILIPROC, V_NRSOLICMP, 1);
         INSERT INTO SOLICITA
          (CDFILSOLI,
           CDFILLANCA,
           NRSOLICMP,
           DTSOLCMP,
           IDTIPLAN,
           CDFILCENT,
           CDOPERLANC)
         SELECT
           P_CDFILIAL,
           P_FILIPROC,
           SUBSTR(V_NRSOLICMP,11,10),
           TO_DATE(SYSDATE),
           'A',
           NVL(CDFILCENTCMP, P_CDFILIAL),
           P_OPERADOR
         FROM
           FILIAL
         WHERE
           FILIAL.CDFILIAL   = P_CDFILIAL;
       END IF;

       V_CDPRODPREF := NULL;
       SELECT
         MAX(PRODPREFMED.CDPRODPREF) INTO V_CDPRODPREF
       FROM
         PRODPREFMED
       WHERE
         PRODPREFMED.CDPRODUTO = C_ESTPROJ.CDPROESTPROJ;

       SELECT
         MAX(VRFATOCONV), MAX(VRARREDCMP) INTO V_VRFATOCONV, V_VRARREDCMP
       FROM
         PRODUTO
       WHERE
         PRODUTO.CDPRODUTO = NVL(V_CDPRODPREF, C_ESTPROJ.CDPROESTPROJ);

       V_QTACOMPRAR := (C_ESTPROJ.QTPROJESTPRO * - 1)/V_VRFATOCONV;
       IF (MOD(V_QTACOMPRAR, V_VRARREDCMP) <> 0) AND V_VRARREDCMP > 0 THEN
          V_QTACOMPRAR := CEIL(V_QTACOMPRAR / V_VRARREDCMP) * V_VRARREDCMP;
       END IF;

       IF V_QTACOMPRAR <= 9999999 THEN
          INSERT INTO ITEMSOLI
           (CDFILSOLI,
            CDFILLAN,
            NRSOLICMP,
            DTPROGENTR,
            CDPRODUTO,
            QTSOLIPROD,
            DTUTILIZA)
          SELECT
            P_CDFILIAL,
            P_FILIPROC,
            SUBSTR(V_NRSOLICMP,11,10),
            C_ESTPROJ.DTPRIFALTEST,
            NVL(V_CDPRODPREF, C_ESTPROJ.CDPROESTPROJ),
            V_QTACOMPRAR,
            C_ESTPROJ.DTPRIFALTEST
          FROM
            PRODUTO
          WHERE
            PRODUTO.CDPRODUTO = NVL(V_CDPRODPREF, C_ESTPROJ.CDPROESTPROJ);
       END IF;
     END LOOP;
   END IF;

   IF P_CONSSOL = 'R' THEN /* CONSIDERAR REQUISICAO DO PERIODO */
      DELETE FROM CONSPLAN
      WHERE CDFILICPLA = P_CDFILIAL
        AND NRCONSPLAN = V_CDSEQUENCIAL;
   END IF;
   COMMIT;
END;
/