# Zh Cache Bypass
Zh Cache Bypass is a component that handles cache problems with web products when requesting metadata JSON files.

## Installation
**1)** First of all, check if you have Private Bower's Registry registered in your **.bowerrc** file.
```js
{
    "registry": {
        "search": [
            "http://192.168.122.56:5678/"
        ]
    }
}
```
**2)** Then install via Bower:
```bash
$ bower install --save zh-cache-bypass
```
**3)** After installed, you need to link the main component's JavaScript file in your index.html:
```html
<script src="bower_components/zh-cache-bypass/src/CacheBypass.js">
```
**4)** Set the version of your product on the window variable *applicationVersion*.
```
window.applicationVersion = 1;
```
Since is impracticable to change the variable off each version manually, it's recommended to use it alogside [ZhEnvironmentBuilder][ZEB].
```js
window.applicationVersion = '<>APPLICATION_VERSION<>';
```

## How it works
The browser caches the files based on the URL used on request. If the file URLs change, the browser will always check for a new file.
Everytime **Zeedhi Framework** requests a json metadata, it triggers the event *EventOnRequestMetaDataStart*. In this event ZhCacheBypass changes the URL appending a query string variable, with the version value, at the end of the URL.
So when the version change, the url change, and the browser will request for the json metadata.

## Handle cache problems on js and css
The CacheBypass service only prevents the cache of JSON files.
To bypass JavaScript and CSS cache, you can use [ZhEnvironmentBuilder][ZEB] to add the version query string at the end of the import URL, like the example below.
```html
<script src="bower_components/zeedhi-frontend/assets/dist/main.js?v=<>APPLICATION_VERSION<>"></script>
```
## Zh Environment Builder
More information about **Zh Environment Builder** can be found [here][ZEB].

[ZEB]: http://code.zeedhi.com/zeedhi/grunt-zh-environment-builder